# coding: utf-8

"""
    Upstox Developer API

    Build your App on the Upstox platform  ![Banner](https://api.upstox.com/api-docs/images/banner.jpg \"banner\")  # Introduction  Upstox API is a set of rest APIs that provide data required to build a complete investment and trading platform. Execute orders in real time, manage user portfolio, stream live market data (using Websocket), and more, with the easy to understand API collection.  All requests are over HTTPS and the requests are sent with the content-type ‘application/json’. Developers have the option of choosing the response type as JSON or CSV for a few API calls.  To be able to use these APIs you need to create an App in the Developer Console and generate your **apiKey** and **apiSecret**. You can use a redirect URL which will be called after the login flow.  If you are a **trader**, you can directly create apps from Upstox mobile app or the desktop platform itself from **Apps** sections inside the **Account** Tab. Head over to <a href=\"http://account.upstox.com/developer/apps\" target=\"_blank\">account.upstox.com/developer/apps</a>.</br> If you are a **business** looking to integrate Upstox APIs, reach out to us and we will get a custom app created for you in no time.  It is highly recommended that you do not embed the **apiSecret** in your frontend app. Create a remote backend which does the handshake on behalf of the frontend app. Marking the apiSecret in the frontend app will make your app vulnerable to threats and potential issues.   # noqa: E501

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Problem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'error_code': 'str',
        'message': 'str',
        'property_path': 'str',
        'invalid_value': 'object'
    }

    attribute_map = {
        'error_code': 'errorCode',
        'message': 'message',
        'property_path': 'propertyPath',
        'invalid_value': 'invalidValue'
    }

    def __init__(self, error_code=None, message=None, property_path=None, invalid_value=None):  # noqa: E501
        """Problem - a model defined in Swagger"""  # noqa: E501
        self._error_code = None
        self._message = None
        self._property_path = None
        self._invalid_value = None
        self.discriminator = None
        if error_code is not None:
            self.error_code = error_code
        if message is not None:
            self.message = message
        if property_path is not None:
            self.property_path = property_path
        if invalid_value is not None:
            self.invalid_value = invalid_value

    @property
    def error_code(self):
        """Gets the error_code of this Problem.  # noqa: E501

        Unique code for the error state  # noqa: E501

        :return: The error_code of this Problem.  # noqa: E501
        :rtype: str
        """
        return self._error_code

    @error_code.setter
    def error_code(self, error_code):
        """Sets the error_code of this Problem.

        Unique code for the error state  # noqa: E501

        :param error_code: The error_code of this Problem.  # noqa: E501
        :type: str
        """

        self._error_code = error_code

    @property
    def message(self):
        """Gets the message of this Problem.  # noqa: E501

        Verbose message for the error state  # noqa: E501

        :return: The message of this Problem.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this Problem.

        Verbose message for the error state  # noqa: E501

        :param message: The message of this Problem.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def property_path(self):
        """Gets the property_path of this Problem.  # noqa: E501

        Path to property failing validation  # noqa: E501

        :return: The property_path of this Problem.  # noqa: E501
        :rtype: str
        """
        return self._property_path

    @property_path.setter
    def property_path(self, property_path):
        """Sets the property_path of this Problem.

        Path to property failing validation  # noqa: E501

        :param property_path: The property_path of this Problem.  # noqa: E501
        :type: str
        """

        self._property_path = property_path

    @property
    def invalid_value(self):
        """Gets the invalid_value of this Problem.  # noqa: E501

        Invalid value for the property failing validation  # noqa: E501

        :return: The invalid_value of this Problem.  # noqa: E501
        :rtype: object
        """
        return self._invalid_value

    @invalid_value.setter
    def invalid_value(self, invalid_value):
        """Sets the invalid_value of this Problem.

        Invalid value for the property failing validation  # noqa: E501

        :param invalid_value: The invalid_value of this Problem.  # noqa: E501
        :type: object
        """

        self._invalid_value = invalid_value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Problem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Problem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
